#ifndef _I_LIBUSB_H
#define _I_LIBUSB_H

#include "defs.h"

#if defined __cplusplus
extern "C" {
#endif

#ifndef __return_values
#define __return_values
enum _return_values {
    RET_FALSE = 0,
    RET_TRUE = 1,
    RET_TRUE_ERR = 2 //non-fatal
};
#endif

#ifndef _s_info
#define _s_info
struct s_info {
    void *handle;
    DWORD flags;
};

enum s_info_flags {
    F_NO = 0
};
#endif
BYTE libusb_get_number(WORD vid, WORD pid, WORD *size);
BYTE libusb_list(WORD vid, WORD pid, WORD *size, struct s_info *arr_flags, WORD array_size);
BYTE libusb_open_(void *handle, WORD vid, WORD pid, void **ret_handle);
BYTE libusb_close_(void *handle);
BYTE libusb_clear(void *handle);

BYTE libusb_write(void *handle, const void *buffer, WORD data_size);
BYTE libusb_read(void *handle, void *buffer, WORD buf_size, DWORD *p_bytes_read);

BYTE libusb_set_timeout(void *handle, WORD timeout);

#if defined __cplusplus
} // extern "C" {
#endif

#endif // _I_LIBUSB_H
