#include <stdio.h>
#include <stdlib.h>
#include <wchar.h>
#include "hidapi.h"

#define ON 0xff
#define OFF 0xfd

int operate_relay(hid_device *handle,unsigned char relay, unsigned char state){
    unsigned char buf[9];// 1 extra byte for the report ID
    int res;

    buf[0] = 0x0; //report number
    buf[1] = state;
    buf[2] = relay;
    buf[3] = 0x00;
    buf[4] = 0x00;
    buf[5] = 0x00;
    buf[6] = 0x00;
    buf[7] = 0x00;
    buf[8] = 0x00;
    res = hid_send_feature_report(handle, buf, sizeof(buf)); //hid_write for linux
    if (res < 0) {
        fprintf(stderr,"Unable to write() %d\n", res);
        fprintf(stderr,"Error: %ls\n", hid_error(handle));
    }
    return(res);
}

int relay_set(int on) { //1 = on, 0 = off, -1 = skip
    //unsigned char buf[9];// 1 extra byte for the report ID
    int i;
    int num_relays, num_relays0 = 0;
    struct hid_device_info *devs, *cur_dev;
    hid_device *handle;

    cur_dev = devs = hid_enumerate(0x16c0, 0x05df);
    while (cur_dev) {
        handle = hid_open_path(cur_dev->path);
        if (!handle) {
            printf("unable to open relay device %s\n", cur_dev->path);
            cur_dev = cur_dev->next;
            continue;
        }

        // The product string is USBRelayx where x is number of relays read to the \0 in case there are more than 9
        num_relays = (char)cur_dev->product_string[8] - '0';
        num_relays0 += num_relays;
/*
        buf[0] = 0;
#ifndef _WIN32
        buf[0] = 1;
#endif
        if (hid_get_feature_report(handle, buf, sizeof(buf)) == -1) {
            perror("hid_get_feature_report");
            cur_dev = cur_dev->next;
            continue
        }
#ifdef _WIN32
        buf++;
#endif
        for ( i = 0; i < num_relays ; i++ )
            printf("%s_%d=%d\n", buf, i+1, (buf[7] & 1 << i) ? 1 : 0);
*/
        if (on >= 0)
            for (i = 1; i <= num_relays; i++)
                operate_relay(handle, i, on ? ON : OFF);

        hid_close(handle);
        cur_dev = cur_dev->next;
    }
    hid_free_enumeration(devs);
    hid_exit();
    return num_relays0;
}
