#pragma once

#include <QDebug>

template <class Type, unsigned int Size>
struct FixedArray {
    Type arr[Size];
    inline unsigned int GetSize() { return Size; }
    inline Type &operator[] (const int i) { return arr[i]; }
    inline const Type &operator[] (const int i) const { return arr[i]; }

    inline bool operator== (const FixedArray<Type, Size> &other) const {
        for (int i = 0; i < (int)Size; i++)
            if (arr[i] != other.arr[i])
                return false;
        return true;
    }
    inline bool operator!= (const FixedArray<Type, Size> &other) const {
        return !(*this == other);
    }
    FixedArray<Type, Size>& operator=(const FixedArray<Type, Size>& right) {
        if (this == &right) {
            return *this;
        }

        for (int i = 0; i < Size; i++)
            arr[i] = right.arr[i];
        return *this;
    }

    inline FixedArray(){}
    inline FixedArray(Type t, ...) {
        Type *p = &t;
        for (int i = 0; i < (int)Size && *p; i++, p++)
            arr[i] = (*p);
    }

    friend QDebug operator<< (QDebug dbg, const FixedArray<Type, Size> &a)
    {
        QDebugStateSaver saver(dbg);
        QString str = "";
        for (int i = 0; i < Size; i++)
            str += QString::number(a[i]) + ", ";
        if (str.length() > 1)
            str.chop(2);
        dbg.nospace() << "(" << str << ")";

        return dbg;
    }
};

typedef FixedArray<double, 2> Range;

/*
QDebug operator<<(QDebug dbg, const Range &r)
{
    dbg << r[0] << r[1];
    return dbg;
}
*/
