#pragma once

#include "plot_basetypes.h"
#include <QEvent>
#include <QRectF>

namespace plot {

class TSelectEvent: public QEvent
{
public:
    enum States {St_SelectChanged, St_SelectionApplied, St_SelectionCancled, St_SelectionStarted};
    enum TSelectRectChangedOrigins { SRO_Unknown, SRO_Mouse, SRO_SetSelect};

    TSelectEvent(const QRectF &Rect, TSelectEvent::States St, TSelectEvent::TSelectRectChangedOrigins Or = SRO_Unknown);

    States State;
    TSelectRectChangedOrigins Origin;
    QRectF SelectedRect;

    static QEvent::Type id;
};

class TCrossEvent: public QEvent
{
public:
    TCrossEvent(const QPointF &Point);
    QPointF Coord;

    static QEvent::Type id;
};

class TScalesChangedEvent: public QEvent
{
public:
    enum TReason {R_BRestoreScale_clicked, R_BApply_clicked, R_SetPlotsXScales_Called, R_SetPlotsYScales_Called};
    TScalesChangedEvent(const Range &XLims, const Range &YLims, TReason Rsn);
    TReason Reason;
    Range XLimits;
    Range YLimits;

    static QEvent::Type id;
};

}
