#include "math_core.h"

namespace plot {
namespace math {

void TMathCore::InitVars(const T2dArray &Arr, const int Sz, const int StartX, const int StartY, const int EndX, const int EndY)
{
    Size = Sz;
    row = StartY; col = StartX;
    height = EndY - StartY; width = EndX - StartX;
    if (Arr.size() == 0)
    {
        data = nullptr;
        return;
    }
    data = new double [Arr.size() * Arr[0].size()];

    for (int Y = 0; Y < Arr.size(); Y++)
        memcpy(data + Y*Arr[0].size(), &Arr[Y][0], sizeof(double) * Arr[Y].size());
}
void TMathCore::on_FilterFinish(T2dArray &Arr)
{
    if (data == nullptr)
        return;
    for (int Y = 0; Y < Arr.size(); Y++)
        memcpy(&Arr[Y][0], data + Y*Arr[0].size(), sizeof(double) * Arr[Y].size());

    delete [] data;
    data = nullptr;
}

}
}
