#ifndef MATH_CORE_H
#define MATH_CORE_H

#include "3d/plot_3dtypes.h"

namespace plot {
namespace math {

class TMathCore
{
public:
    void InitVars(const T2dArray &Arr, const int Sz, const int StartX, const int StartY, const int EndX, const int EndY);
    void on_FilterFinish(T2dArray &Arr);

    double *data; //TODO in-place
    int Size;
    int row, col;
    int height, width;
};

class TMedian
{
public:
    double CalcMedian(QVector<double> &V) const
    { return CalcMedian(V.begin(), V.end()); }
    template <class TIter>                       //Begin           End
    double CalcMedian(const TIter B, const TIter E) const
    {
        unsigned int Size = E - B;
        if (Size == 0)
            return 0;

        int lo = 0, hi = Size - 1, median = Size/2, middle, ll, hh;
        //TODO sort + ret?
        while (true)
        {
            if (hi <= lo) return B[median];
            if (hi == lo + 1) { if (B[lo] > B[hi]) qSwap(B[lo], B[hi]); return B[median]; }
            middle = (lo + hi) / 2;      //Find median of lo, middle and hi items; swap into position lo
            if (B[middle] > B[hi])  qSwap(B[middle], B[hi]);
            if (B[lo] > B[hi])      qSwap(B[lo],     B[hi]);
            if (B[middle] > B[lo])  qSwap(B[middle], B[lo]);
            qSwap(B[middle], B[lo + 1]); //Swap low item (now in position middle) into position (lo+1)
            ll = lo + 1; hh = hi;        //Nibble from each end towards middle, swapping items when stuck
            while (true)
            {
                do { ll++; } while (B[lo] > B[ll]);
                do { hh--; } while (B[hh] > B[lo]);
                if (hh < ll) break;
                qSwap(B[ll], B[hh]);
            }
            qSwap(B[lo], B[hh]);      //Swap middle item (in position lo) back into correct position
            if (hh <= median) lo = ll; //Re-set active partition
            if (hh >= median) hi = hh - 1;
        }
    }

};

}
}

#endif // MATH_CORE_H
