#include "fixedsplitter.h"
#include <QDebug>
#include <QEvent>
#include <QResizeEvent>

FixedSplitter::FixedSplitter(QWidget *parent) : QSplitter(parent)
{
    setStyleSheet("QSplitter::handle:horizontal {width: 0px;}\
                   QSplitter::handle:vertical  {height: 0px;}");
    setHandleWidth(0);

}

void FixedSplitter::resizeEvent(QResizeEvent *event)
{
    if (event->type() == QEvent::Resize/* && handle(1)*/)
    {
        handle(1)->setEnabled(true);
        QSplitter::resizeEvent(event);
        handle(1)->setEnabled(false);
    }
}

bool FixedSplitter::event(QEvent *event)
{
    return QSplitter::event(event);
}

void FixedSplitter::setFixed()
{
    if (!handle(1))
        return;

    handle(1)->setEnabled(false);
    handle(1)->setCursor(Qt::ArrowCursor);
}

void FixedSplitter::addWidget(QWidget *widget)
{
    QSplitter::addWidget(widget);

    setFixed();
}

void FixedSplitter::insertWidget(int index, QWidget *widget)
{
    QSplitter::insertWidget(index, widget);

    setFixed();
}

void FixedSplitter::MoveSplit(int width)
{
    moveSplitter(width,0);
}

//QWidget *FixedSplitter::replaceWidget(int index, QWidget *widget)
//{
//    auto wid = QSplitter::replaceWidget(index, widget);

//    setFixed();
//    return wid;
//}
