#pragma once

#include <QGroupBox>
#include <QLabel>
#include <QLineEdit>
#include <QPushButton>
#include <QActionGroup>
#include <QToolButton>
#include <QMenu>

class HFlowLayout;
class QGridLayout;
#include "../../src/gui/controls.h"

namespace plot {

class TMarkersInfo: public QGroupBox
{
protected:
    QGridLayout *GLMarkerA;
    QGridLayout *GLMarkerB;
    QGridLayout *GLDownL;
    static const int MaxWidth = 80;

public:
    void GUICreate();

    QLineEdit *LEdXA;
    QLabel *LXAUnit;

    QLineEdit *LEdYA;
    QLabel *LYAUnit;

    QLineEdit *LEdXB;
    QLabel *LXBUnit;

    QLineEdit *LEdYB;
    QLabel *LYBUnit;

    QLineEdit *LEdDeltaX;
    QLabel *LDeltaXUnit;

    QLineEdit *LEdDeltaY;
    QLabel *LDeltaYUnit;

    QLineEdit *LEdQ;
    QLabel *LQv;

    QLineEdit *LEdDistance;
    QLabel *LDistanceUnit;

    QLineEdit *LEdAngle;
    QLabel *LAngleLbl;
    QLabel *LAngleUnit;
};

class TCommonPlotControl: public QGroupBox
{
    Q_OBJECT
public slots:
    void SetSelectionModeEnabled(bool State);
    void BApplyAndCancelSetVisible(bool State);
    void on_BAutoScale_toggled();
    void on_BFixX_clicked();
    void on_BFixY_clicked();
    void on_BFixX_toggled();
    void on_BFixY_toggled();

public:
    void GUICreate();

    HFlowLayout *ControlMainLayout;

    QPushButton *BMarkers;
    QPushButton *BDetailedMarkersInfo;
    QPushButton *BAngle;
    QPushButton *BGrid;

    QPushButton *BFixX;
    QPushButton *BFixY;
    QPushButton *BExpandSelectRect;
    QPushButton *BSelectByRect;
    QPushButton *BRestoreScale;
    QPushButton *BAutoScale;

    QMenu *MMathProcessing;
    QToolButton *TBMathProcessing;

    QToolButton *TBFontSize;
    QActionGroup *AGFontSizes;

    QPushButton *BSavePlotPixmap;
    QPushButton *BSave;

    QPushButton *BApply;
    QPushButton *BCancel;
};

}
