#pragma once

#include <QString>

#define SPECTR_PORT_IN 0
#define SPECTR_PORT_OUT 1

class QWidget;

class I_SPECTR
{
public:
    I_SPECTR() { }
    virtual ~I_SPECTR() {}

    virtual bool initialize(int num = 0) = 0;
    virtual bool shutdown() = 0;

    virtual QString getName() = 0;
    virtual bool isReady() = 0;

    virtual bool preparePixelWl(double pixelsize, int nx, int central_pixel) = 0; //mm
    virtual double getPixelWl(int pixel_idx) = 0; //nm

    virtual bool setWl(double wl, bool reset = false) = 0; //nm
    virtual double getWl() = 0; //nm
    virtual double getDispersion() = 0; //nm/mm

    virtual int getGratingCount() = 0;
    virtual QString getGratingName(int idx) = 0;
    virtual bool setActiveGrating(int idx, bool reset = false) = 0;
    virtual int getActiveGrating() = 0;

    //mkm
    virtual bool setSlitWidth(int port, double width) = 0;
    virtual double getSlitWidth(int port) = 0;

    virtual bool setPortPosition(int port, int idx) = 0;
    virtual int getPortPosition(int port) = 0;

    virtual QWidget *createInterfaceWidget() { return nullptr; }

    bool initialized = false;
};
