#ifndef ASCIFILE_H_
#define ASCIFILE_H_

#include <QString>
#include <plot.h>

class ascifile
{
public:
    ascifile(QString filename);

    void set_instrument(QString instrument);
    void set_data_name(QString data_name);
    void set_x_type(QString type_x);
    void set_y_type(QString type_y);
    void set_xpts(int n);
    void set_ypts(int n);
    void set_x_data(const double *x);
    void set_y_data(const double *y);
    void set_array(plot::T2dArray _data);
    void set_xsz(Range &n);
    void set_ysz(Range &n);

    void write_file();
    void write_file_3d();
    QString realToString(const double);

private:
    QString filename;
    QString dataname;
    QString instrument;
    QString X_name;
    QString Y_name;
    int xpts;
    int ypts;
    const double *data_x;
    const double *data_y;
    plot::T2dArray data;
    Range xsz, ysz;
};

#endif /* ASCIFILE_H_ */
