#ifndef CONTAINER_NSTFILE_H
#define CONTAINER_NSTFILE_H

#include "cont_basetypes.h"
#include <QTextStream>
#include <2d/plot_2dtypes.h>
#include <3d/plot_3dtypes.h>

class QuaZip;
class QuaZipFile;
class TNstFileHandler : public QObject
{
    Q_OBJECT
signals:
    void FileProccessed(double TotalNumber, double Current);
    void AllDataLoaded(const TAbstractInfos *DataList);
    void DoAddBlanks(int Num);
    void Error(QString component, QString msg);

public slots:
    void progress4d(double);
    void setLoadProgress(int idx, double load);

private:
    QTextStream Stream;

    QuaZipFile *DataInput1;
    double readDataSize;
    int NumberOfFiles, CurrentFileNumber;
    QVector<double> loadProgress;

    void SaveData(plot::TCurvesDataOwner *Info, plot::TMetaStorage attributes);
    void SaveItem(const plot::TCurveData *Item);
    void SaveData(plot::T3dDataOwner *Info, plot::TMetaStorage attributes);
    void SaveData(ccd::TSetOfSpectrum *Info, plot::TMetaStorage attributes);
    void SaveData(QImage *Info, plot::TMetaStorage attributes);

    int CalcNumOfInfos(QuaZip *Archive);

public:
    TNstFileHandler();
    ~TNstFileHandler() override {}

    void Save(const QString &FileName, const TAbstractInfos &Data, bool oldFormat);
    void Load(const QString &FileName, TAbstractInfos &Data);
};

#endif // CONTAINER_NSTFILE_H
