#ifndef SPCFILE_H_
#define SPCFILE_H_

#include "SPC.h"
#include <time.h>
#include <QString>

class spcfile
{
public:
    spcfile(QString filename);

    void set_time(time_t * t);
    void set_instrument_descr(char * s);
    void set_comment(char * s);
    void set_x_type(char t);
    void set_y_type(char t);
    void set_exper(char t);
    void set_npts(int n);
    void set_x_data(const float *x);
    void set_y_data(const float *y);
    int write_file(void);

private:
    SPCHDR hdr;
    SUBHDR shdr;

    QString filename;

    time_t * ext_time;
    time_t cur_time;
    tm * splited_time;

    int npts;

    const float *data_x;
    const float *data_y;
};

#endif /* SPCFILE_H_ */
