#pragma once

#include <QWidget>
#include <QPushButton>

class QGestureEvent;
class DeflectWid : public QWidget
{
    Q_OBJECT

public slots:
    void setXY(double x, double y);
    void setInt(float i);
    void setMag(QString Mag_new);
    void setDfl(QString Dfl_new);
    void setLfl(QString Lfl_new);
    void setZpos(float Zpos_new);
    void setTuningFork(bool);
    void setFbscanner(int value);
    void setSTM(bool);
    void newOscMAGData(QList<double>, int, int);
    void newOscHeightRMS(double, QString);

signals:
    void doubleClicked();

protected:
    bool event(QEvent *) override;
    void paintEvent(QPaintEvent *event) override;
    bool gestureEvent(QGestureEvent *event);

private:
    QPixmap pixmap;
    QPixmap TuneFork;
    QPixmap DflPix;
    QPixmap LflPix;

    bool bSnotra;
    bool bSTM;

    QFont font;
    int FBscanner;

    const static int FONT_SCALE = 18;
    const static int SPOT_SCALE = 2;
    double X = 0., Y = 0.;
    QString MAG, DFL, LFL;
    float Zpos;
    float intens = 0.;
    void mouseDoubleClickEvent(QMouseEvent *Event) override;
    void inline drawFreqCurveGraph(QPainter *painter, int fontsize);
    void inline drawOscMagCurve(QPainter *painter, int fontsize);

    QPolygonF freqCurve;
    QPolygonF freqCurveDraw;
    float fresX = 0.0;

    QVector<double> oscMagCurve;
    int lastIdOscMagCurve = 0;
    int frameRater = 0;
    int oscTime = 1;

    QString oscHeightRMS = "";

public:
    DeflectWid();
    void SetFreqCurveDataMaximum(float yMax);
    void virtual AddFreqCurveData(int x, qreal y);
    void setQ(bool reset, double min = -1., double max = -1.);

    QPushButton *probeCheckScanBtn;
    QString qValue;
};
