#ifndef DATALISTOVERLAYBUTTONS_H
#define DATALISTOVERLAYBUTTONS_H

#include <QObject>
#include <QWidget>
#include <QPushButton>
#include <QTabWidget>
#include "container/datalist.hpp"
#include "colorrect.h"

class TContainer;

class DataListOverlayButtons : public QWidget
{
    Q_OBJECT
public:
    explicit DataListOverlayButtons(TContainer *container, QTabWidget *tabWid);
    static void setButtonStyle(QPushButton *btn, bool active = false);

    QPushButton *BToDevice;
    QPushButton *BToAscii;
    QPushButton *BToOldNSpec;

    QList<QPushButton*> allBtnsList;
    colorRect *background;

    static const int UpButtonSize = 55;

signals:

public slots:
    void resized(QSize newSize);
    void setVisibleButtons(bool visible);

private:
    TContainer *container;
    QTabWidget *DataLists;

    QPushButton *BToGwyddion;
    QPushButton *BSave;
    QPushButton *BSaveAs;
    QPushButton *BOpen;
    QPushButton *BMerge;
    QPushButton *BAddTab;
};

#endif // DATALISTOVERLAYBUTTONS_H
