#ifndef HOVERBUTTON_H
#define HOVERBUTTON_H

#include <QObject>
#include <QWidget>

class HoverButton : public QWidget
{
    Q_OBJECT
public:
    enum Direction {LeftArrow, RightArrow, TopArrow, BottomArrow, Circle};

    explicit HoverButton(Direction dir, QColor boundColor, QWidget *parent = nullptr);
    void paintEvent(QPaintEvent *) override;
    void mousePressEvent(QMouseEvent *) override;
    void mouseReleaseEvent(QMouseEvent *) override;
    bool pressed = false;
    QString text = "";
    QFont font;
    QColor fontColor = Qt::white;

signals:
    void holdingPressed(bool pressed);

private:
    Direction direction;
    QColor boundColor;

public slots:
};

#endif // HOVERBUTTON_H
