#include "manystatebutton.h"

ManyStateButton::ManyStateButton(QList<QString> paths, QWidget *parent) : QPushButton(parent)
{
    imgs = paths;
    numStates = paths.count();
    state = 1;
    setIcon(makeHugeIcon(paths.first()));
    connect(this, SIGNAL(clicked()), SLOT(onClickedThreeStateButton()));
}

void ManyStateButton::onClickedThreeStateButton()
{
    change_state(state+1);
}

void ManyStateButton::changeIcon(const QString &icon)
{
    setIcon(makeHugeIcon(icon));
}

void ManyStateButton::change_state_man(int st)
{
    if (state == st)
        return;

    if (st > numStates || st < 1)
        st = 1;

    int oldSt = state;
    state = st;
    changeIcon(imgs[state - 1]);

    emit state_changed_man(oldSt, state);
}

void ManyStateButton::change_state(int st)
{
    if (state == st)
        return;
    int oldSt = state;
    change_state_man(st);
    emit state_changed(oldSt, state);
}
