#ifndef MANYSTATEBUTTON_H
#define MANYSTATEBUTTON_H

#include <QObject>
#include <QWidget>
#include <QIcon>
#include <QLineEdit>
#include <QFrame>
#include <QPushButton>
#include <QTimer>
#include "controls.h"
#include <QDebug>

class ManyStateButton : public QPushButton
{
    Q_OBJECT
public:
    explicit ManyStateButton(QList<QString> paths, QWidget *parent = nullptr);
    int state;

public slots:
    void change_state_man(int st);
    void change_state(int st);
    void onClickedThreeStateButton();

signals:
    void state_changed(int oldSt, int newSt);
    void state_changed_man(int oldSt, int newSt);

private:
    int numStates = 0;
    QList<QString> imgs;
    void changeIcon(const QString &icon);
};

#endif // MANYSTATEBUTTON_H
