#include "qdoubleclickbutton.h"
#include <QtEvents>
#include <QGestureEvent>
#include <QPainter>
#include <QPainterPath>
#include <QDebug>
#include <QtGlobal>

QDoubleClickButton::QDoubleClickButton(const QString &text, QWidget *parent) : QPushButton(text, parent)
{

}
bool QDoubleClickButton::event(QEvent *event)
{
    if (event->type() == QEvent::Gesture) {
        return gestureEvent(static_cast<QGestureEvent*>(event));
    }
    return QWidget::event(event);
}
void QDoubleClickButton::mouseDoubleClickEvent(QMouseEvent * /*Event*/)
{
    emit doubleClicked();
}
bool QDoubleClickButton::gestureEvent(QGestureEvent *event)
{
    if (event->gesture(Qt::TapAndHoldGesture))
        mouseDoubleClickEvent(nullptr);

    return true;
}
