#ifndef ABSTRACTINOUTLINES_H
#define ABSTRACTINOUTLINES_H

#include <QPoint>
#include <QVector>
#include <QWidget>
#include <QEvent>
#include <QGraphicsDropShadowEffect>

inline bool QEventResizedMoved(QEvent *e)
{
    return e->type() == QEvent::GraphicsSceneMove ||
           e->type() == QEvent::GraphicsSceneResize ||
           e->type() == QEvent::Resize;
}

class AbstractInOutLines
{
public:
    AbstractInOutLines(uint numOut, uint numIn);
    ~AbstractInOutLines();

    void connectAbs(int mineOutId, AbstractInOutLines *other, int otherInId);
    void setPtsInXY(int id, int x, int y);
    void setPtsOutXY(int id, int x, int y);
    void addCorner(int outId, int x, int y);

    virtual void recalcPoints() = 0;

    const uint countOut;
    const uint countIn;
    QList<QPoint*> ptsOut;
    QList<QPoint*> ptsIn;
    QList<QVector<QPoint*>*> cornersOut;
    QList<AbstractInOutLines*> absOut;
    QList<AbstractInOutLines*> absIn;
    uint *connectOutId; //which In input connected Out in absOut

    //todo move it to another interface
    void setPosXY(int x, int y);
    void setShadow(QWidget *wid, int w, const QColor &color);
    QColor backgroundColor;
    QColor outterLineColor = Qt::black;
    int outterLineWidth = 1;
    QPoint *absPos; //position of QWidget
    double maxFontScale = 1.5;
};

#endif // ABSTRACTINOUTLINES_H
