#ifndef SCHDIODESIGNALS_H
#define SCHDIODESIGNALS_H

#include <QObject>
#include <QWidget>
#include "abstractinoutlines.h"
#include <QtEvents>
#include <QGestureEvent>
#include <QPainter>
#include <QDebug>
#include <QtGlobal>
#include <QTimer>
#include <QLabel>
#include <QPaintEngine>

class schDiodeSignals : public QWidget, public AbstractInOutLines
{
    Q_OBJECT
public:
    explicit schDiodeSignals(QWidget *parent = nullptr);
    void recalcPoints() override;
    int miniBoxY[3];
    int boxY;
    int miniBoxH;
    QLabel *textDFL;
    QLabel *textLFL;
    QLabel *textINT;

protected:
    bool event(QEvent *) override;
    void paintEvent(QPaintEvent *event) override;

private:
    inline void initPositions(int w, int h);
    int boxX;
    int boxW;
    int boxH;
    int maxWidthMinBox;

signals:
    void recalc();
    void initPos(int w, int h);

public slots:
};

#endif // SCHDIODESIGNALS_H
