#include "schextosc.h"

schExtOsc::schExtOsc(QWidget *parent) : QWidget(parent), AbstractInOutLines(0, 0)
{
    headText = new QLabel(tr("Ext Osc"), this);
    headText->setScaledContents(true);
    initPositions(0, 0);
}

void schExtOsc::initPositions(int w, int h)
{
    boxX = 0;
    boxY = h*0.2;
    boxW = w;
    boxH = h - boxY;

    double scale = w/75.;
    if (scale > maxFontScale)
        scale = maxFontScale;
    headText->setFont(QFont(headText->font().family(), 10*scale));
    headText->adjustSize();
}

void schExtOsc::recalcPoints()
{
    initPositions(width(), height());
}

bool schExtOsc::event(QEvent *e)
{
    if (QEventResizedMoved(e))
        recalcPoints();

    return QWidget::event(e);
}

void schExtOsc::paintEvent(QPaintEvent *)
{
    QPainter painter(this);

    int w = width();
    int h = height();

    initPositions(w, h);
    painter.setRenderHint(QPainter::Antialiasing, true);

    //Box
    painter.setPen(QPen(QBrush(outterLineColor), outterLineWidth));
    painter.setBrush(QBrush(backgroundColor));
    painter.drawRect(boxX, boxY, boxW, boxH);
    painter.setBrush(QBrush());

    painter.setPen(QColor(Qt::black));

    //Ext Osc text
    headText->move(boxX, boxY - headText->height());
}
