#ifndef PSO_H
#define PSO_H

#include <QObject>
#include <QWidget>
#include "abstractinoutlines.h"
#include <QtEvents>
#include <QGestureEvent>
#include <QPainter>
#include <QDebug>
#include <QtGlobal>
#include <QTimer>
#include <QPaintEngine>
#include <QLabel>

class schPSD : public QWidget, public AbstractInOutLines
{
    Q_OBJECT
public:
    explicit schPSD(QWidget *parent = nullptr);
    void recalcPoints() override;
    bool spmLaserOff;

protected:
    bool event(QEvent *) override;
    void paintEvent(QPaintEvent *event) override;

private:
    inline void initPositions(int w, int h);
    bool hovered;
    int boxX;
    int boxY;
    int boxW;
    QPoint ellBCenter;
    QPoint ellLCenter;
    int ellBRadius;
    QLabel *headText;
    QImage *laserImgOff;
    QImage *laserImgOn;
    QImage *laserImgHovered;

signals:
    void ChangedValue(bool laserOFF);

public slots:
};

#endif // PSO_H
