#pragma once

#include <QLabel>
class StatusWidget : public QLabel
{
public:
    enum Shape {
        Square = 0,
        Circle,
        Cross,
        Play,
        Up,
        Down,
        Custom
    };

    StatusWidget(int size)
    {
        if (size < 0) size = 0;
        if (size > 9999) size = 9999;
        setFixedSize(size, size);
    }
    void set(Shape shape, QBrush brush, QPixmap custom = QPixmap());

};

class StatusWidget1 : public QWidget
{
public:
    StatusWidget1(QString text = QString());

    void setEmulator(bool set)
    {
        label->setStyleSheet(set ? "QLabel { border: 2px solid blue }" : "");
    }

    QLabel *label;
    StatusWidget *status;

};

enum EDeviceStatus {
    EDno = 0,
    EDconn,
    EDok,
    EDplay
};

//-----

#include <QToolBar>
#include <QProgressBar>
#include <QPushButton>
class StatusBar : public QToolBar
{
    Q_OBJECT

signals:
    void canceled();

public slots:
    void setValue(int val);

public:
    StatusBar(QString status, int max = 0);
    ~StatusBar() override;

    void add();

    QLabel *statusLabel;
    QProgressBar *bar;
    QPushButton *cancel;

};
template <class T>
void destructStatus(T &bar) {
    if (bar != nullptr) {
        bar->hide();
        delete bar;
        bar = nullptr;
    }
}
class QStatusBar;
void setMainStatusBar(QStatusBar *bar);
int statusBarCount();
void cancelAllStatusBars();

class Notification : public StatusBar
{
public:
    enum Tint { None, Good, Warn, Bad };
    Notification(QString status, Tint tint = Warn, int timeout = 0); //s, 0=never
    void setTint(Tint tint = Warn);
};
