#ifndef SWAPTWOSTATEBUTTON_H
#define SWAPTWOSTATEBUTTON_H

#include <QObject>
#include <QWidget>
#include <QPushButton>
#include "controls.h"
#include <QGestureEvent>
#include <QDebug>

namespace swapDir {
    enum Direction{dir_right, dir_down};
}

class swapTwoStateButton : public QPushButton
{
    Q_OBJECT

public slots:
    void change_state();
    void change_state_noEmit();
    void change_state_man(bool);
    void change_state_man_with_sig(bool st);

protected:
    bool event(QEvent *event) override;

public:


    swapTwoStateButton(QString offRight, QString offDown, QString on);
    swapTwoStateButton(const QString & text, QString offRight, QString offDown, QString on);
    void changeDirection(swapDir::Direction dir, bool emitChange);

    QString offstring[2];
    QString onstring;
    bool on_off; //todo rename that variable

    swapDir::Direction dir = swapDir::dir_right;

signals:
    void state_changed(bool);
    void swapped(swapDir::Direction);

private:
    QPoint mousePressedPoint;
    bool blockClick = false;
};

#endif // SWAPTWOSTATEBUTTON_H
