#ifndef THREESTATEBUTTON_H
#define THREESTATEBUTTON_H

#include <QIcon>
#include <QLineEdit>
#include <QFrame>
#include <QPushButton>
#include <QTimer>
#include "controls.h"
#include <QDebug>

class ThreeStateButton : public QPushButton
{
    Q_OBJECT

public slots:
    void change_state_man(int st);
    void change_state(int st);

signals:
    void state_changed(int oldSt, int newSt);
    void state_changed_man(int oldSt, int newSt);

private slots:
    void timerState2Ended();
    void onClickedThreeStateButton();
    void changeIcon(const QString &icon);

private:
    int state;
    QString iconSt1;
    QString iconSt3;
    QTimer *state2Timer;
    int currentAnimIcon;
    int iconSizeWidth;

public:
    ThreeStateButton(const QString &st1, const QString &st3, double scale = 0.0);
    ~ThreeStateButton();
    int minRectWidth() const;

    int getState() const;
    int aminationState2Period;
};

#endif // THREESTATEBUTTON_H
